# RepasoPOOCoches

> Este ejercicio fue hecho sin mirar el temario y entregado fuera de plazo por motivos agenos al ciclo, por lo que independientemente de resultados, agradecer al profesor a cargo de la asignatura por mirarlo igualmente pese a dichas condiciones, así por el apoyo ofrecido. También quiero que quede de aviso para otros posibles compañeros que quieran hacer uso de este contenido por posiblemente no ceñirse a lo requerido en la asignatura. Sea como sea, espero sea útil para aprender y reciclarse como lo fue para mi.

Este es un ejercicio de repaso que hay dentro de la asignatura de Programación de Servicios y Procesos. La idea es conseguir gestionar diferentes tipos de coches a partir de clases heredadas y repasar el ámbito de los atributos y elementos de clase y objeto.

A modo de estructuración del proyecto tenemos 3 directorios a modo de paquetes para:

- **Interfaces**: Aquí irán las interfaces asignadas al ejercicio.
- **Abstracciones**: Aquí irán las abstracciones (Clases abstractas) asignadas al ejercicio.
- **Marcas**: Paquete hecho a modo de modelos de cada una de las marcas que se vayan a trabajar aquí.

> El ejercicio en sí no me tenía mucha lógica funcional, así que lo fui adaptando para poder alcanzar un fin funcional en cuestión. Uno de los grandes problemas que encontré esla sobreescritura de los métodos de control del vehículo, que teóricamente han de ser iguales para todos y lo que varían en sí serían los parámetros que usen. Para poder hacer un "Override" de éstos, expuse una interfaz de la cual partan obligatoriamente dichos métodos. Para que los métodos sean distintos entre las distintas marcas, se establece un valor numérico personalizado según la marca.

La abstracción **Coche** implementa de forma heredada la interfaz **Coches** para que al definir cada marca, ésta tenga la obligación de crear dicho método. También tiene ciertos parámetros comunes a todos los coches, los cuales han de ser sobreescritos por cada Marca implementada.

> Para que todo esto tenga sentido, el constructor de cada marca operará en base al rendimiento del coche: un valor porcentual en base decimal, es decir, 1 sería el 100%, que determinará el rendimiento, velocidad máxima y capacidad del tanque de combustible, a mayores de la customización implementada en cada marca.

Finalmente, se implementaron las marcas:

- **Ford**
- **Peugeut**
- **Renault**
- **Toyota**

```mermaid
flowchart TD

I["Coches (Interfaz)"]
A["Coche (Abstracta)"]
F[Ford]
P[Peugeut]
R[Renault]
T[Toyota]

I --> A
A --> F
A --> P
A --> R
A --> T

```

La Interfaz **Coches** obligará a construir los métodos:

- **acelerar**
- **frenar**: Se entenderá como una aceleración negativa.
- **repostar**

En la clase principal **RepasoPOOCoches** se montarán todos los vehículos que se quieran en base al parámetro de configuración allí existente, que depende de los propios Coches existentes en Marcas como clases-objeto, en una tabla de datos la cual será migrada en el *main* a un ArrayList el cual luego ordenará mediante **sort** y un *Arrow Function* (Equivalente a crear un objeto *Comparator* y el Override de *compare*) donde se hará una comparativa mediante un valor numérico que determina si es mayor o menor que el objeto anterior, comparando, en este caso, mediante casteo a *Coche*, las potencias de todos los coches creados. Tras ésto, ejecutará cada uno de los métodos de la Interfaz e imprimirá, mediante el método *toString*, de forma automática, los datos del vehículo para determinar tanto su orden como el correcto funcionamiento de todo.